PROGRAM Test;
USES Crt, Sorts;

CONST
  MinArraySize = 1;
  MaxArraySize = 10;

TYPE
  PtrArray = ARRAY[MinArraySize..MaxArraySize] OF Pointer;

FUNCTION SimpleComparePtrs (VAR AnArray; Item1, Item2 : LongInt) : Integer;
         FAR;
BEGIN
  IF Char(PtrArray(AnArray)[Item1]^) < Char(PtrArray(AnArray)[Item2]^)
     THEN SimpleComparePtrs := -1
     ELSE SimpleComparePtrs := Ord(Char(PtrArray(AnArray)[Item1]^) <>
                             Char(PtrArray(AnArray)[Item2]^));
END;

FUNCTION ComplexComparePtrs (VAR AnArray; Item1, Item2 : LongInt) : Integer;
         FAR;
BEGIN
  IF Char(Pointer(Item1)^) < Char(PtrArray(AnArray)[Item2]^)
     THEN ComplexComparePtrs := -1
     ELSE ComplexComparePtrs := Ord(Char(Pointer(Item1)^) <>
                             Char(PtrArray(AnArray)[Item2]^));
END;

FUNCTION TreeComparePtrs (VAR AnArray; Item1, Item2 : LongInt) : Integer;
         FAR;
BEGIN
  IF Char(Pointer(Item1)^) < Char(Pointer(Item2)^)
     THEN TreeComparePtrs := -1
     ELSE TreeComparePtrs := Ord(Char(Pointer(Item1)^) <>
                             Char(Pointer(Item2)^));
END;

VAR C : PtrArray;
    i : LongInt;
    j, k : Integer;
    Ch : ^Char;

BEGIN
  Randomize;
  FOR i := 1 TO 11 DO
    BEGIN
        { initialize array }
      FOR j := MaxArraySize DOWNTO MinArraySize DO
        BEGIN
          k := Random(255);
          WHILE (k < 65) OR (k > 90) DO k := Random(255);
          New(Ch);
          Ch^ := Char(k);
          C[j] := Ch;
        END;
        { display unsorted data }
      ClrScr;
      CASE i OF
        1 : WriteLn('Binary Insertion Sort');
        2 : WriteLn('Bubble Sort');
        3 : WriteLn('Comb Sort');
        4 : WriteLn('Heap Sort');
        5 : WriteLn('Quick Sort');
        6 : WriteLn('Non-recursive Quick Sort');
        7 : WriteLn('Shaker Sort');
        8 : WriteLn('Shell Sort');
        9 : WriteLn('Straight Insertion Sort');
       10 : WriteLn('Straight Selection Sort');
       11 : WriteLn('Tree Sort');

      END;
      FOR j := MinArraySize TO MaxArraySize  DO Write(Char(C[j]^):2);
        { sort data }
      CASE i OF
        1 : BinaryInsertionSort(C,MinArraySize,MaxArraySize,SimpleComparePtrs,SwapPtrs);
        2 : BubbleSort(C,MinArraySize,MaxArraySize,SimpleComparePtrs,SwapPtrs);
        3 : CombSort(C,MinArraySize,MaxArraySize,SimpleComparePtrs,SwapPtrs);
        4 : HeapSort(C,MinArraySize,MaxArraySize,ComplexComparePtrs,SwapPtrs);
        5 : QuickSort(C,MinArraySize,MaxArraySize,ComplexComparePtrs,SwapPtrs);
        6 : QuickSortNonRecursive(C,MinArraySize,MaxArraySize,
                                  ComplexComparePtrs,SwapPtrs);
        7 : ShakerSort(C,MinArraySize,MaxArraySize,SimpleComparePtrs,
                       SwapPtrs);
        8 : ShellSort(C,MinArraySize,MaxArraySize,SimpleComparePtrs,
                      SwapPtrs);
        9 : StraightInsertionSort(C,MinArraySize,MaxArraySize,
                                  ComplexComparePtrs,SwapPtrs);
       10 : StraightSelectionSort(C,MinArraySize,MaxArraySize,
                                  SimpleComparePtrs,SwapPtrs);
       11 : TreeSort(C,MinArraySize,MaxArraySize,TreeComparePtrs,SwapPtrs);
      END;
        { display sorted data }
      WriteLn;
      FOR j := MinArraySize TO MaxArraySize  DO Write(Char(C[j]^):2);
        { clear of collection }
      ReadLn;
    END;
END.